var service;// service you are connected to
var from;	// person you are talking to
var to;		// you
var editor; // message editor
var atomizer = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService).getAtom;
var fontSize = 3;

function load() {
	service = window.arguments[0];
	from = window.arguments[1];
	to = window.arguments[2];
	if (window.arguments[3] != null)
		addMessage("<b><font color=\"#16569E\">" + from + "</font></b>", window.arguments[3]);

	document.getElementById('message').makeEditable('html',false);
	editor = document.getElementById('message').getHTMLEditor(document.getElementById('message').contentWindow);
	editor.isCSSEnabled = false;
	document.getElementById('forecolor').color = "#000000";
	document.getElementById('chatWindow').setAttribute("title", from);
	audioscrobblerFeed();
}
function addMessage(from, message, autoResponse) {
	if (autoResponse)
		message = "<b>(Auto response)</b> " + message;
	var dialogueBody = document.getElementById('dialogue').contentWindow.document.body;
	regexp= new RegExp("<html[^>.]*>", "gi")
	message = message.replace(new RegExp("<html[^>.]*>", "gi"), "");// get rid of <html>'s
	message = message.replace(new RegExp("</html[^>.]*>", "gi"), "");// get rid of </html>'s
	message = message.replace(new RegExp("<body[^>.]*>", "gi"), "");// get rid of <body>'s
	message = message.replace(new RegExp("</body[^>.]*>", "gi"), "");// get rid of </body>'s
	if (message.indexOf('<br>') == -1)
		message += "<br>";

	dialogueBody.innerHTML += "<font size=\"1\">(" + (new Date()).toLocaleTimeString() + ")</font> " + from + ": " + message;
	dialogueBody.scrollTop = dialogueBody.scrollHeight - dialogueBody.clientHeight;
	window.getAttention();
}
function getInfo() {
	service.getInfo(from);
}
function send() {
	var message = document.getElementById('message').contentWindow.document.body.innerHTML;
	service.send(from, message);
	addMessage("<b><font color=\"#A82F2F\">" + to + "</font></b>", message);
	document.getElementById('message').contentWindow.document.body.innerHTML = "";
}
function testKey(event) {
	var atom, first = {}, any = {}, all = {};
	if (event.keyCode == 13 && !event.shiftKey) {
		send();
		return;
	}
	else if (event.keyCode == 66 && event.ctrlKey)	{	// bold
		atom = atomizer('b');
		document.getElementById('bold').checked = !document.getElementById('bold').checked;
	} else if (event.keyCode == 73 && event.ctrlKey) {	// italic
		atom = atomizer('i');
		document.getElementById('italic').checked = !document.getElementById('italic').checked;
	} else if (event.keyCode == 85 && event.ctrlKey) {	// underline
		atom = atomizer('u');
		document.getElementById('underline').checked = !document.getElementById('underline').checked;
	} else
		return;

	editor.getInlineProperty(atom, '', '', first, any, all);
	if (first.value) {
		editor.removeInlineProperty(atom, '');
		editor.removeDefaultProperty(atomizer(atom), '', '');
	} else {
		editor.setInlineProperty(atom, '', '');
		editor.addDefaultProperty(atomizer(atom), '', '');
	}
}
function preventNewLine(event) {
	if (event.keyCode == 13 && !event.shiftKey) {			// prevent new line
		event.preventDefault();
		return;
	}
}
function changeStyle(atom, sender) {
	if (!sender.checked) {
		editor.setInlineProperty(atomizer(atom), '', '');
		editor.addDefaultProperty(atomizer(atom), '', '');
	} else {
		editor.removeInlineProperty(atomizer(atom), '');
		editor.removeDefaultProperty(atomizer(atom), '', '');
	}
}
function url(event) {
	if (event.target.localName == "A") {
		event.preventDefault();
		window.open(event.target.getAttribute('href'), '', '');
	}
}
function updateFontSize() {
	fontSize = fontSize == 0 ? 1 : (fontSize > 7 ? 7 : fontSize);
	editor.setInlineProperty(atomizer('font'), 'size', fontSize);
}

function audioscrobblerFeed() {
	//service.sendFlap(service.DATA, "toc_set_info \"<a href='http://audioscrobbler.com/user/cuv'>Musical Profile</a>\"");
	if (!service.displayInfoUsername) {	// busy right now
		service.audioscrobblerCallback = this.audioscrobblerLoop;
		service.getInfo(from);
	} else
		setTimeout("audioscrobblerFeed()", 10000);	// try again
}
var artist = "";
var audioUser = "";
function audioscrobblerLoop(username) {
	if (username == "<not found>") {
		audioUser = "";
		document.getElementById('audioStartLabel').value = 'Buddy doesn\'t have an Audioscrobbler ID - ';
		document.getElementById('middleLabel').value = '';
		document.getElementById('audioscrobbler').value = 'Learn more';
		setTimeout("document.getElementById('audioStartLabel').value = '';document.getElementById('audioscrobbler').value = '';", 20000);
		return;
	}
	audioUser = username;
	var req = new XMLHttpRequest();
	req.open('GET', "http://ws.audioscrobbler.com/rdf/history/" + username, true);
	req.onreadystatechange = function (aEvt) {
		if (req.readyState == 4) {
			if (req.status == 200) {
				var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].getService(Components.interfaces.nsIDOMParser);
				var doc = parser.parseFromString(req.responseText, "text/xml");
				var nodeList = doc.getElementsByTagName ("description");
				if (nodeList.length > 1) {
					document.getElementById('audioStartLabel').value = username;
					document.getElementById('middleLabel').value = "is listening to: ";
					document.getElementById('audioscrobbler').value = nodeList.item(1).textContent;	// todo - be smarter about getting rdf data
					artist = doc.getElementsByTagName("Artist").item(0).textContent;
				} else {
					document.getElementById('audioStartLabel').value = 'No recent tracks played by buddy';
					document.getElementById('middleLabel').value = '';
					document.getElementById('audioscrobbler').value = '';
					artist = '';
				}
				setTimeout("audioscrobblerLoop('" + username + "')", 120000);	// keep getting a feed
			}
			setTimeout("audioscrobblerLoop('" + username + "')", 30000);	// try again
		}
	};
	req.send(null);
}
function userLink() {
	var text = document.getElementById('audioscrobbler').value;
	window.open('http://audioscrobbler.com/user/' + audioUser,'Audioscrobbler');
}
function amazonLink() {
	var text = document.getElementById('audioscrobbler').value;
	if (text == "loading..." || text == "" || text == "Learn more") {
		window.open('http://aimfire.mozdev.org/audioscrobbler.html','Audioscrobbler');
		return;
	}
//	var artist = text.substring(text.indexOf(':') + 1, text.indexOf('-'));
//	artist = artist.replace(new RegExp("\\s", "gi"), "%" + "20");
	window.open('http://www.chasaidthekitty.com/amazon.php?artist=' + artist,'Audioscrobbler');
}
